#include <stdio.h>
#define MAXN 200000
#define NK 7

int n, i, j, k, code;
int music[MAXN];
int d[MAXN][NK][NK];
int R[MAXN][2];

int test(int i, int j, int k) {
	return j >= 0 && k >= 0 && j < NK && k < NK && (music[i] == j || music[i] == k);
}

int main() {
	scanf("%d", &n);
	for (i = 0; i < n; ++i) {
		scanf("%d", music + i);
		--music[i];
	}
	for (i = 0; i < n; ++i)
		for (j = 0; j < NK; ++j)
			for (k = 0; k < NK; ++k)
				d[i][j][k] = ((i == 0 && test(i, j, k)) ? 0 : -1);
	for (i = 0; i < n - 1; ++i)
		for (j = 0, code = 0; j < NK; ++j)
			for (k = 0; k < NK; ++code, ++k) {
				if (d[i][j][k] == -1) continue;
				if (test(i + 1, j - 1, k)) d[i + 1][j - 1][k] = code;
				if (test(i + 1, j + 1, k)) d[i + 1][j + 1][k] = code;
				if (test(i + 1, j, k - 1)) d[i + 1][j][k - 1] = code;
				if (test(i + 1, j, k + 1)) d[i + 1][j][k + 1] = code;
				if (test(i + 1, j, k)) d[i + 1][j][k] = code;
			}
	j = music[n - 1];
	for (k = 0; k < NK; ++k)
		if (d[n - 1][j][k] != -1)
			break;
	if (k == NK) {
		printf("NO\n");
		return 0;
	}
	printf("YES\n");
	for (i = n - 1; i >= 0; --i) {
		code = d[i][j][k];
		R[i][0] = j + 1;
		R[i][1] = k + 1;
		j = code / 7;
		k = code % 7;
	}
	for (i = 0; i < n; ++i)
		printf("%d %d\n", R[i][0], R[i][1]);
	return 0;
}
