#include <iostream>
#include <vector>

using namespace std;

const int alphSize = 1e+5 + 1;

int main() {
	int n;
	cin >> n;
	vector<int> a(n);

	for (int i = 0; i < (int)a.size(); ++i) {
		cin >> a[i];
	}

	vector<int> letCnt(alphSize, 0);

	int r = 0;
	pair<int, int> ans(0, 0);

	for (int l = 0; l < (int)a.size(); ++l) {
		if (l == r) {
			letCnt[a[l]]++;
			r++;
		}
		while (r < (int)a.size() && letCnt[a[r]] == 0) {
			letCnt[a[r]]++;
			r++;
		}
		letCnt[a[l]]--;
		if (r - l > ans.first) {
			ans = make_pair(r - l, l);
		}
	}
	
	cout << ans.first << endl;
	for (int i = ans.second; i < ans.first + ans.second; ++i)
		cout << a[i] << " ";
	cout << endl;
	return 0;
}
